Skip to content

GET API Endpoints.

GET
/api/ml/data/namespaces/{namespace}/virtual_hosts/{name}/api_endpoints
curl --request GET \
--url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/ml/data/namespaces/example/virtual_hosts/example/api_endpoints \
--header 'Authorization: <Authorization>'

GET all autodiscovered API endpoints for Virtual Host.

namespace
required
string

Namespace Namespace of the virtual host for current request.

name
required
string

Virtual Host Name Virtual Host name for current request.

api_endpoint_info_request
Array<string>
Allowed values: API_ENDPOINT_INFO_NONE API_ENDPOINT_INFO_PDF_SPARKLINES

List of additional things that needs to be sent as part of the request

API ENDPOINT INFO NONE option is used to disable any additional info request per API endpoint response API ENDPOINT INFO PDF SPARKLINES option is used to enable pdf sparkline info along with the API endpoint response.

domains
Array<string>

List of domains that needs to be sent as part of the request Optional filter by domains. If absent, all domains are considered.

start_time
string

Format: unix_timestamp|RFC 3339 Filters the APIEPs with access time >= start_time. Considered only to calculate activity metrics, based on #sec-events and #requests. Optional: If not specified, then the start_time will be evaluated to end_time-2h If end_time is not specified, then the start_time will be evaluated to -10m.

end_time
string

Format: unix_timestamp|RFC 3339 Filters the APIEPs with access time < end_time. Considered only to calculate activity metrics, based on #sec-events and #requests. Optional: If not specified, then the end_time will be evaluated to start_time+2h If start_time is not specified, then the end_time will be evaluated to

apiep_category
Array<string>
Allowed values: APIEP_CATEGORY_DISCOVERED APIEP_CATEGORY_SWAGGER APIEP_CATEGORY_INVENTORY APIEP_CATEGORY_SHADOW APIEP_CATEGORY_DEPRECATED APIEP_CATEGORY_NON_API

Category of API endpoints. Can be DISCOVERED, INVENTORY or SHADOW API. Optional filter by api_category. If absent, endpoints of all categories are considered.

Discovered API Endpoint. The API Endpoint is imported from user swagger. The API Endpoint is present at the API Inventory. The API Endpoint is considered as part of Shadow API. Deprecated API Endpoint. Non-API Endpoint.

A successful response.

Media typeapplication/json
API endpoints GET response

Response shape for GET API endpoints API. It is list of API endpoints discovered.

object
apiep_list
API endpoints list

List of API endpoints discovered.

Array<object>
Identified API

Information about automatically identified API endpoint Each identified API endpoint has a CollapsedURL and Method. CollapsedURL is created by replacing dynamic components in the URL, if any, with the keyword DYN. These dynamic components are automatically identified. Additionally, any API endpoint that has a collapsedURL with automatically identified DYN components, will also have DYN-Examples which show a few examples of the original values of the components that were determined to be DYN.

object
access_discovery_time
access_discovery_time

Access_discovery_time is the time when the API endpoint was updated from the access logs by the discovery mechanism. It is the UTC time and represented in RFC3339 form.

string format: date-time
<= 1024 characters
api_groups
API Groups membership

List of API Groups the API Endpoint is a member of.

Array<string>
api_type
string
default: API_TYPE_UNKNOWN
Allowed values: API_TYPE_UNKNOWN API_TYPE_GRAPHQL API_TYPE_REST API_TYPE_GRPC
attributes
attributes

List of API endpoint attributes.

Array<string>
authentication_state
string
default: AUTH_STATE_UNKNOWN
Allowed values: AUTH_STATE_UNKNOWN AUTH_STATE_AUTHENTICATED AUTH_STATE_UNAUTHENTICATED
authentication_types
authentication_types

List of authentication types found in the API endpoint and their locations.

Array<object>
APIEP Authentication Type and Location Pair

API Endpoint’s Authentication Type and Location.

object
auth_type
auth_type

The detected authentication type by string format.

string
<= 1024 characters
location
string
default: AUTH_LOCATION_HEADER
Allowed values: AUTH_LOCATION_HEADER AUTH_LOCATION_QUERY AUTH_LOCATION_BODY AUTH_LOCATION_COOKIE
type
string
default: AUTH_TYPE_BASIC
Allowed values: AUTH_TYPE_BASIC AUTH_TYPE_BEARER AUTH_TYPE_JWT AUTH_TYPE_API_KEY AUTH_TYPE_OAUTH2 AUTH_TYPE_OPENID AUTH_TYPE_HTTP AUTH_TYPE_OAUTH1 AUTH_TYPE_DIGEST AUTH_TYPE_NEGOTIATE
avg_latency
avg_latency

Average latency observed for the API Endpoint.

number format: float
base_path
base_path

The base path for this Endpoint.

string
<= 1024 characters
category
Category

The category of the API Endpoint relative to API Inventory.

Array<string>
Allowed values: APIEP_CATEGORY_DISCOVERED APIEP_CATEGORY_SWAGGER APIEP_CATEGORY_INVENTORY APIEP_CATEGORY_SHADOW APIEP_CATEGORY_DEPRECATED APIEP_CATEGORY_NON_API
collapsed_url
Identified API

URL for automatically identified API.

string
<= 1024 characters
compliances
compliances

List of compliance frameworks of the Endpoint.

Array<string>
domains
List of domains

List of Domains of the API endpoint.

Array<string>
dyn_examples
Expanded URL(s)

For example - {“dyn_examples”: [ { “component_identifier”: “API/v1/user_id/DYN”, “component_examples”: [ “cmenomo007”, “marcusaurelius” “artattacksince1947”, “johndoe83”, ] }, { “component_identifier”: “API/v1/user_id/DYN/vehicle_id/DYN”, “component_examples”: [ “JN1CV6AR3AM458367”, “1GBCS10AXP2917522”, “JM1DE1KY9D0155647”, “JN1CA31D5YT533780” ] } ]} List of sample URL(s) that are collapsed and dynamic components to collapse them.

Array<object>
API endpoint dynamic example

List of Examples of expanded URL components for API endpoints that are collapsed with a dynamic component that is identified automatically.

object
component_examples
List of expanded URLs

List of sample URL(s) that are collapsed.

Array<string>
component_identifier
Dynamic component

Dynamic component used to collapse sample URLs given in Expanded URLs.

string
<= 1024 characters
engines
engines

List of engines that detected the endpoint.

Array<string>
err_rsp_count
error status code count

Number of request with 4xx or 5xx response for the API Endpoint.

string format: uint64
<= 1024 characters
has_learnt_schema
Has Learnt Schema

Has Learnt Schema flag for request API endpoint.

boolean format: boolean
last_tested
last api testing

API testing last tested time is the time when the API endpoint was last tested.

string format: date-time
<= 1024 characters
max_latency
max_latency

Maximum latency observed for the API Endpoint.

number format: float
method
HTTP method

HTTP method for the API.

string
<= 1024 characters
pdf_info
object
creation_timestamp
creation_timestamp

Creation_timestamp represents the time when this PDF was created It is represented in RFC3339 form and is in UTC.

string format: date-time
<= 1024 characters
error_rate
PDF(error rate)

List of Probability density points for PDF for error rate.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
error_rate_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
latency_no_data
PDF(response latency to first byte)

List of Probability density points for PDF for latency of response begin.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
latency_no_data_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
latency_with_data
PDF(response latency)

List of Probability density points for PDF for latency of response end.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
latency_with_data_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
request_rate
PDF(request rate)

List of Probability density points for PDF for request rate.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
request_rate_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
request_size
PDF(request_size)

List of Probability density points for PDF for request size.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
request_size_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
response_size
PDF(response_size)

List of Probability density points for PDF for response size.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
response_size_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
response_throughput
PDF(response throughput)

List of Probability density points for PDF for response throughput.

Array<object>
Probability Density Point(x,y)

Probability Density point in (PDF(x)) of the metric. X is the value of the metric, probability is the corresponding PDF(x). In the univariate case (current configuration), the value x of the metrics is a scaler. As PDFSpec is repeated (see below), the x values are linearly spaced monotonically from minimum to maximum.

object
probability
Probability

Probability of given Value of the metric that can be plotted on y-axis.

number format: float
x
Metric Value

Value of the metric that can be plotted on x-axis.

number format: float
response_throughput_stat
object
pdf_95
PDF 95th Percentile

Pdf_95 represents the 95th percentile of PDF.

number format: float
pdf_mean
PDF Mean

Pdf_mean represents the mean of PDF.

number format: float
pii_level
string
default: APIEP_PII_NOT_DETECTED
Allowed values: APIEP_PII_NOT_DETECTED APIEP_PII_DETECTED
req_rate
req_rate

Request rate for the API Endpoint.

number format: float
request_percentage
Request percentage

Percentage of requests that were directed to this API Endpoint.

number format: float
requests_count
requests_count

Number of requests seen for this API Endpoint for the specified time-range.

integer format: int32
risk_score
object
score
score

Score of the vulnerabilities found for this API Endpoint.

number format: float
severity
string
default: APIEP_SEC_RISK_NONE
Allowed values: APIEP_SEC_RISK_NONE APIEP_SEC_RISK_LOW APIEP_SEC_RISK_MED APIEP_SEC_RISK_HIGH APIEP_SEC_RISK_CRITICAL
schema_status
schema_status

Schema status indicates the API Endpoint’s schema origin and if it’s outdated.

string
<= 1024 characters
sec_events_count
sec_events_count

Number of sec_events seen for this API Endpoint for the specified time-range.

integer format: int32
security_risk
string
default: APIEP_SEC_RISK_NONE
Allowed values: APIEP_SEC_RISK_NONE APIEP_SEC_RISK_LOW APIEP_SEC_RISK_MED APIEP_SEC_RISK_HIGH APIEP_SEC_RISK_CRITICAL
sensitive_data
List of Sensitive Data

List of Sensitive Data found in the API endpoint.

Array<string>
Allowed values: SENSITIVE_DATA_TYPE_CCN SENSITIVE_DATA_TYPE_SSN SENSITIVE_DATA_TYPE_IP SENSITIVE_DATA_TYPE_EMAIL SENSITIVE_DATA_TYPE_PHONE SENSITIVE_DATA_TYPE_CREDENTIALS SENSITIVE_DATA_TYPE_APP_INFO_LEAKAGE SENSITIVE_DATA_TYPE_MASKED_PII SENSITIVE_DATA_TYPE_LOCATION
sensitive_data_location
sensitive data location

Sensitive data location for the API Endpoint.

Array<string>
sensitive_data_types
List of Sensitive Data

List of Sensitive Data found in the API endpoint.

Array<string>
owasp_categories
owasp_categories

Categories of the vulnerability as per the OWASP API Top 10.

Array<object>
OWASP Category

Represents a category of vulnerability as defined in the OWASP API Top 10.

object
link_to_owasp
OWASP reference link

Link to the OWASP documentation for this category.

string
<= 1024 characters
name
Category name

The name of the OWASP API security category.

string
>= 6 characters <= 1024 characters
last_update
last_update

The API endpoints Last Update timestamp indicates most recent update of API endpoints happened The API Discovery periodically updates the API endpoints list based on application’s traffic.

string format: date-time
<= 1024 characters
Example
{
"apiep_list": [
{
"api_type": "API_TYPE_UNKNOWN",
"authentication_state": "AUTH_STATE_UNKNOWN",
"authentication_types": [
{
"location": "AUTH_LOCATION_HEADER",
"type": "AUTH_TYPE_BASIC"
}
],
"category": [
"APIEP_CATEGORY_DISCOVERED"
],
"pii_level": "APIEP_PII_NOT_DETECTED",
"risk_score": {
"severity": "APIEP_SEC_RISK_NONE"
},
"security_risk": "APIEP_SEC_RISK_NONE",
"sensitive_data": [
"SENSITIVE_DATA_TYPE_CCN"
]
}
]
}

Returned when operation is not authorized.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when there is no permission to access resource.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when resource is not found.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation on resource is conflicting with current value.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation has been rejected as it is happening too frequently.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server encountered an error in processing API.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when service is unavailable temporarily.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server timed out processing request.

Media typeapplication/json
string format: string
Examplegenerated
example